package rocks.zipcode.quiz5.collections;

import java.util.HashMap;
import java.util.Map;

public class WordCounter {
    private HashMap<String, Integer> wordCounter;

    public WordCounter(String... strings) {
        this.wordCounter = new HashMap<>();
        for(String s : strings){
            if (wordCounter.containsKey(s)){
                wordCounter.put(s, wordCounter.get(s)+1);
            }else{
                wordCounter.put(s, 1);
            }
        }
    }

    public Map<String, Integer> getWordCountMap() {
        return wordCounter;
    }
}
