package rocks.zipcode.quiz5.fundamentals;

import java.util.ArrayList;
import java.util.HashSet;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        int middleIndex = string.length()/2;
        return string.charAt(middleIndex);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middleIndex = str.length()/2;
        String middleChar = getMiddleCharacter(str).toString().toUpperCase();
        return str.substring(0,middleIndex)+middleChar+str.substring(middleIndex+1);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middleIndex = str.length()/2;
        String middleChar = getMiddleCharacter(str).toString().toLowerCase();
        return str.substring(0,middleIndex)+middleChar+str.substring(middleIndex+1);
    }

    public static Boolean isIsogram(String str) {
        char[] letters = str.toCharArray();
        boolean isIsogram = true;
        for (int i = 0; i < letters.length; i++){
            for(int j = i+1; j < letters.length; j++){
                if (letters[i] == letters[j]){
                    isIsogram = false;
                    break;
                }
            }
        }
        return isIsogram;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        char[] letters = str.toCharArray();
        boolean hasDups = false;
        for (int i = 0; i < letters.length-1; i++){
            if(letters[i] == letters[i+1]){
                hasDups = true;
                break;
            }
        }
        return hasDups;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        StringBuilder sb = new StringBuilder();
        char dup = ' ';
        for(int i = 0; i < str.length(); i++){
            if(i < str.length()-1 && str.charAt(i) == str.charAt(i+1) || str.charAt(i) == dup) {
                dup = str.charAt(i);
            }else{
                sb.append(str.charAt(i));
            }
        }

        return sb.toString();
    }

    public static String invertCasing(String str) {
        StringBuilder invertCase = new StringBuilder();
        for (int i = 0; i < str.length(); i++){
            char ch = str.charAt(i);
            char ch1;
            if (Character.isLowerCase(ch)){
                ch1 = Character.toUpperCase(ch);
            }else{
                ch1 = Character.toLowerCase(ch);
            }
            invertCase.append(ch1);

        }

        return invertCase.toString();
    }
}