package rocks.zipcode.quiz5.fundamentals;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * @author leon on 21/12/2018.
 */
public class Calculator {
    public static Double squareRoot(Double value) {
        return Math.sqrt(value);
    }

    public static Double square(Double value) {
        return Math.pow(value, 2);
    }

    public static Double[] squareRoots(Double... value) {
        ArrayList<Double> sr = new ArrayList<>();
        for(Double v : value){
            sr.add(squareRoot(v));
        }
        Double[] newArray = new Double[sr.size()];
        newArray = sr.toArray(newArray);
        return newArray;
    }

    public static Double[] squares(Double... values) {
        ArrayList<Double> sr = new ArrayList<>();
        for(Double v : values){
            sr.add(square(v));
        }
        Double[] newArray = new Double[sr.size()];
        newArray = sr.toArray(newArray);
        return newArray;
    }

    public static Double add(Double value1, Double value2) {
        return value1+value2;
    }

    public static Double subtract(Double value1, Double value2) {
        return value1-value2;
    }


    public static Double divide(Double divisor, Double dividend) {
        return divisor/dividend;
    }
}
