package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee implements Transactable, Worker{
    BankAccount ba;
    Double hourlyWage;
    Double hoursWorked;



    public Employee() {
        this.ba = new BankAccount();
        this.hourlyWage = 35.0;
        this.hoursWorked = 0.0;

    }

    public Employee(BankAccount bankAccount) {
        this.ba = bankAccount;
    }

    public BankAccount getBankAccount() {
        return ba;
    }

    public void setBankAccount(BankAccount bankAccount) {
        this.ba = bankAccount;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        ba.deposit(amountToIncreaseBy);

    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        ba.withdrawal(amountToDecreaseBy);

    }

    @Override
    public Double getBalance() {
        return ba.getBalance();
    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        this.hoursWorked = hoursWorked+numberOfHours;

    }

    @Override
    public Double getHoursWorked() {
        return hoursWorked;
    }

    @Override
    public Double getHourlyWage() {
        return hourlyWage;
    }

    @Override
    public Double getMoneyEarned() {
        return hourlyWage * hoursWorked;
    }
}
